'SPI25C040 SPI Basic 10/2006
'PIC 16F877 4MHz
'tools:- Hardware Uart Sim, as display device

'uart display format is:-
'EEProm hex DATA, ASCII

AllDigital

Define SPI_CS_REG = PORTC
Define SPI_CS_BIT = 0
Define SPI_SCK_REG = PORTC
Define SPI_SCK_BIT = 3
Define SPI_SDI_REG = PORTC
Define SPI_SDI_BIT = 4  '5
Define SPI_SDO_REG = PORTC
Define SPI_SDO_BIT = 5  '4
SPIPrepare

Const wrsr = 1  'wr to eeprom status reg
Const wrlo = 2  'wr to 000 thru 255 eeprom address
Const rdlo = 3  'rd 000 thru 255 address
Const wrdi = 4  'eeprom write disable
Const rdsr = 5  'rd eeprom status reg
Const wrenb = 6  'eeprom write enable
Const wrhi = 10  'wr to 256 thru 511 eeprom address
Const rdhi = 11  'rd 256 thru 511 address


Dim saddr As Word  'eeprom start wr/rd address
Dim faddr As Word  'eeprom finish wr/rd address
Dim strlen As Word  'length of bytes to wr/rd

Dim inc1 As Byte
Dim pntr As Byte  'pointer for lookup strings
Dim cntr As Byte

Dim data As Byte  'eeprom wr/rd data
Dim hnyb As Byte  'high nybble
Dim lnyb As Byte
Dim temp As Byte


'Hseropen 9600

main:
Gosub wrsr1  'wr status reg
Gosub rdsr1  'rd status reg

'write in page mode
saddr = 0x14c  'set start address' A8=1
strlen = 10
Gosub writepage

'write byte by byte
saddr = 0xfc
faddr = 0x105
'''strlen = 10  '' strlen option
Gosub writebytes

'read a string
saddr = 0x14c
strlen = 4
Gosub readstring

'read bytes by byte
saddr = 0xfc
faddr = 0xff
Gosub readbytes
'Break
Goto main


End                                               

wrsr1:
SPICSOn
SPISend wrsr
SPISend 0x08  'bp0
SPICSOff
Return                                            

rdsr1:
SPICSOn
SPISend rdsr  'rdsr
SPIReceive data
SPICSOff
data = data Or 0x30
'Hserout data, " sreg", CrLf
Return                                            

writepage:
'this routine is a part PAGE write to the EEProm
'REM: a PAGE is from xxxx,0000 thru xxxx,1111
'16 bytes of data Max, if your start addr=xxxx,0000
'after the address, keep sending the data bytes
'the 25C040 will auto inc the address.
'REM: dont cross the page boundry with your string
'stop at address xxxx,1111 and send a new address cycle
'for demonstration,this example crosses the page boundary
'enter with saddr as start address
'strlen as number of byte to write
'Hserout "Write Page", CrLf
SPICSOn
SPISend wrenb  'set WREN latch
SPICSOff  'this CS off MUST be sent.

wrnew1:
SPICSOn
If saddr.HB = 0 Then
SPISend wrlo
Else
SPISend wrhi
Endif

SPISend saddr.LB
strlen.LB = strlen.LB - 1

For pntr = 0 To strlen.LB
data = LookUp("Page Write"), pntr
SPISend data
'''Gosub show
Next pntr
done1:
SPICSOff
Return                                            

writebytes:
'this routine writes to eeprom 1 byte at a time
'addr1,data1,addr2,data......
'enter with saddr, strlen
'its slower than writing addr[start],data1,data1..
'but you dont have to calculate the page boundrys
'Hserout "Write Byte", CrLf

SPICSOn
SPISend wrenb
SPICSOff

pntr = 0

'strlen = saddr + strlen ''strlen option
For saddr = saddr To faddr  ''strlen

SPICSOn

'auto insert a8=1 as required
If saddr.HB = 0 Then
SPISend wrlo
Else
SPISend wrhi
Endif

SPISend saddr.LB
data = LookUp("Byte Write"), pntr
pntr = pntr + 1
If pntr > 10 Then pntr = 0

SPISend data
SPICSOff
'''Gosub show
Next saddr
Return                                            


readstring:
'REM: after a write sequence, the WREN latch must
'be reset before you start a READ cycle
'Hserout "Read Page", CrLf
SPICSOn
SPISend wrdi  '4  'WRDI, reset WREN
SPICSOff

'this routine reads a string of data from the EEProm
'enter with saddr=start address and strlen=number of bytes to read
'page boundarys are auto adjusted in the 25C040, so you
'can read multiple bytes after one initial address

SPICSOn

'auto adjust for a8
If saddr.HB = 0 Then  'test for saddr 0 to 255 or 256 to 511
SPISend rdlo  'read command
Else
SPISend rdhi
Endif

SPISend saddr.LB

For cntr = 1 To strlen.LB
SPIReceive data
Gosub show
Next cntr

SPICSOff
Return                                            


readbytes:
'REM: after a write sequence, the WREN latch must
'be reset before you start a READ cycle
'Hserout "Read Byte", CrLf
SPICSOn
SPISend wrdi  'reset WREN
SPICSOff

'this routine reads 1 byte at a time from the EEProm
'the address passes thru the 0ff/100 hex boundary as an example
'enter with saddr=start address and faddr=finish addr
For strlen = saddr To faddr
SPICSOn
If strlen.HB = 0 Then
SPISend rdlo  'read command
Else
SPISend rdhi
Endif

SPISend strlen.LB
SPIReceive data
SPICSOff
Gosub show
Next strlen
Return                                            


show:
'temp = addr
'Gosub show1
temp = data
Gosub show1
'Hserout "  ", data, CrLf
Return                                            

'convert 8 bit bin byte to 3 asc hex characters
show1:
hnyb = temp
lnyb = temp
lnyb = lnyb And 0x0f

hnyb = ShiftRight(hnyb, 4)
hnyb = hnyb And 0x0f

If hnyb > 9 Then
hnyb = hnyb + 55
Else
hnyb = hnyb Or 0x30
Endif

If lnyb > 9 Then
lnyb = lnyb + 55
Else
lnyb = lnyb Or 0x30
Endif

'Hserout hnyb, lnyb, "   "
Return                                            
